diff --git a/Changelog b/Changelog
index f6e3dbb..07fe6ca 100644
--- a/Changelog
+++ b/Changelog
@@ -1,4 +1,7 @@
 
+Version 2.0.12
+ * Fixed bug: keepalive connection was hanging after upload has been completed.
+
 Version 2.0.11
  * Fixed bug: rb->buf was uninitiazlied at some execution paths. Found by Andrew Filonov.
  * Fixed bug: dummy field would not appear whenever form contains only non-file fields.
diff --git a/ngx_http_upload_module.c b/ngx_http_upload_module.c
index 0512772..f711dce 100644
--- a/ngx_http_upload_module.c
+++ b/ngx_http_upload_module.c
@@ -719,6 +719,10 @@ static ngx_int_t ngx_http_upload_body_handler(ngx_http_request_t *r) { /* {{{ */
         ngx_sprintf(r->headers_in.content_length->value.data, "%O", r->headers_in.content_length_n)
             - r->headers_in.content_length->value.data;
 
+#if defined nginx_version && nginx_version >= 8011
+    r->main->count--;
+#endif
+
     if(uri->len != 0 && uri->data[0] == '/') {
         rc = ngx_http_internal_redirect(r, uri, &args);
     }
